Package org.apache.calcite.avatica

## Enum Meta.DatabaseProperty

- java.lang.Object
- - java.lang.Enum<Meta.DatabaseProperty>
  - - org.apache.calcite.avatica.Meta.DatabaseProperty

All Implemented Interfaces:
  `java.io.Serializable`, `java.lang.Comparable<Meta.DatabaseProperty>`

Enclosing interface:
  Meta

    public static enum Meta.DatabaseProperty
    extends java.lang.Enum<Meta.DatabaseProperty>

Database property.

Values exist for methods, such as `DatabaseMetaData.getSQLKeywords()`, which always return the same value at all times and across connections.

See Also:
  `Meta.getDatabaseProperties(Meta.ConnectionHandle)`

### Enum Constant Summary

Enum Constants
`AVATICA_VERSION` Database property which is the Avatica version
`GET_DATABASE_MAJOR_VERSION` Database property containing the value of `DatabaseMetaData.getDatabaseMajorVersion()`.
`GET_DATABASE_MINOR_VERSION` Database property containing the value of `DatabaseMetaData.getDatabaseMinorVersion()`.
`GET_DATABASE_PRODUCT_NAME` Database property containing the value of `DatabaseMetaData.getDatabaseProductName()`.
`GET_DATABASE_PRODUCT_VERSION` Database property containing the value of `DatabaseMetaData.getDatabaseProductVersion()`.
`GET_DEFAULT_TRANSACTION_ISOLATION` Database property containing the value of `DatabaseMetaData.getDefaultTransactionIsolation()`.
`GET_DRIVER_MAJOR_VERSION` Database property containing the value of `DatabaseMetaData.getDriverMajorVersion()`.
`GET_DRIVER_MINOR_VERSION` Database property containing the value of `DatabaseMetaData.getDriverMinorVersion()`.
`GET_DRIVER_NAME` Database property containing the value of `DatabaseMetaData.getDriverName()`.
`GET_DRIVER_VERSION` Database property containing the value of `DatabaseMetaData.getDriverVersion()`.
`GET_NUMERIC_FUNCTIONS` Database property containing the value of `DatabaseMetaData.getNumericFunctions()`.
`GET_S_Q_L_KEYWORDS` Database property containing the value of `DatabaseMetaData.getSQLKeywords()`.
`GET_STRING_FUNCTIONS` Database property containing the value of `DatabaseMetaData.getStringFunctions()`.
`GET_SYSTEM_FUNCTIONS` Database property containing the value of `DatabaseMetaData.getSystemFunctions()`.
`GET_TIME_DATE_FUNCTIONS` Database property containing the value of `DatabaseMetaData.getTimeDateFunctions()`.

### Field Summary

Fields
`java.lang.Object` `defaultValue`
`boolean` `isJdbc`
`java.lang.reflect.Method` `method`
`java.lang.Class<?>` `type`

### Constructor Summary

Constructors
`private` `DatabaseProperty​(T defaultValue)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`static Meta.DatabaseProperty` `fromProto​(Common.DatabaseProperty proto)`
`<T> T` `getProp​(java.util.Map<Meta.DatabaseProperty,​java.lang.Object> map, java.lang.Class<T> aClass)` Returns a value of this property, using the default value if the map does not contain an explicit value.
`<T> T` `getProp​(Meta meta, Meta.ConnectionHandle ch, java.lang.Class<T> aClass)` Returns a value of this property, using the default value if the map does not contain an explicit value.
`Common.DatabaseProperty` `toProto()`
`static Meta.DatabaseProperty` `valueOf​(java.lang.String name)` Returns the enum constant of this type with the specified name.
`static Meta.DatabaseProperty[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### GET_NUMERIC_FUNCTIONS

    public static final Meta.DatabaseProperty GET_NUMERIC_FUNCTIONS

Database property containing the value of `DatabaseMetaData.getNumericFunctions()`.

#### GET_STRING_FUNCTIONS

    public static final Meta.DatabaseProperty GET_STRING_FUNCTIONS

Database property containing the value of `DatabaseMetaData.getStringFunctions()`.

#### GET_SYSTEM_FUNCTIONS

    public static final Meta.DatabaseProperty GET_SYSTEM_FUNCTIONS

Database property containing the value of `DatabaseMetaData.getSystemFunctions()`.

#### GET_TIME_DATE_FUNCTIONS

    public static final Meta.DatabaseProperty GET_TIME_DATE_FUNCTIONS

Database property containing the value of `DatabaseMetaData.getTimeDateFunctions()`.

#### GET_S_Q_L_KEYWORDS

    public static final Meta.DatabaseProperty GET_S_Q_L_KEYWORDS

Database property containing the value of `DatabaseMetaData.getSQLKeywords()`.

#### GET_DEFAULT_TRANSACTION_ISOLATION

    public static final Meta.DatabaseProperty GET_DEFAULT_TRANSACTION_ISOLATION

Database property containing the value of `DatabaseMetaData.getDefaultTransactionIsolation()`.

#### AVATICA_VERSION

    public static final Meta.DatabaseProperty AVATICA_VERSION

Database property which is the Avatica version

#### GET_DRIVER_VERSION

    public static final Meta.DatabaseProperty GET_DRIVER_VERSION

Database property containing the value of `DatabaseMetaData.getDriverVersion()`.

#### GET_DRIVER_MINOR_VERSION

    public static final Meta.DatabaseProperty GET_DRIVER_MINOR_VERSION

Database property containing the value of `DatabaseMetaData.getDriverMinorVersion()`.

#### GET_DRIVER_MAJOR_VERSION

    public static final Meta.DatabaseProperty GET_DRIVER_MAJOR_VERSION

Database property containing the value of `DatabaseMetaData.getDriverMajorVersion()`.

#### GET_DRIVER_NAME

    public static final Meta.DatabaseProperty GET_DRIVER_NAME

Database property containing the value of `DatabaseMetaData.getDriverName()`.

#### GET_DATABASE_MINOR_VERSION

    public static final Meta.DatabaseProperty GET_DATABASE_MINOR_VERSION

Database property containing the value of `DatabaseMetaData.getDatabaseMinorVersion()`.

#### GET_DATABASE_MAJOR_VERSION

    public static final Meta.DatabaseProperty GET_DATABASE_MAJOR_VERSION

Database property containing the value of `DatabaseMetaData.getDatabaseMajorVersion()`.

#### GET_DATABASE_PRODUCT_NAME

    public static final Meta.DatabaseProperty GET_DATABASE_PRODUCT_NAME

Database property containing the value of `DatabaseMetaData.getDatabaseProductName()`.

#### GET_DATABASE_PRODUCT_VERSION

    public static final Meta.DatabaseProperty GET_DATABASE_PRODUCT_VERSION

Database property containing the value of `DatabaseMetaData.getDatabaseProductVersion()`.

### Field Detail

#### type

    public final java.lang.Class<?> type

#### defaultValue

    public final java.lang.Object defaultValue

#### method

    public final java.lang.reflect.Method method

#### isJdbc

    public final boolean isJdbc

### Constructor Detail

#### DatabaseProperty

    private DatabaseProperty​(T defaultValue)

### Method Detail

#### values

    public static Meta.DatabaseProperty[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (Meta.DatabaseProperty c : Meta.DatabaseProperty.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static Meta.DatabaseProperty valueOf​(java.lang.String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
  `java.lang.NullPointerException` - if the argument is null

#### getProp

    public <T> T getProp​(Meta meta,
                         Meta.ConnectionHandle ch,
                         java.lang.Class<T> aClass)

Returns a value of this property, using the default value if the map does not contain an explicit value.

#### getProp

    public <T> T getProp​(java.util.Map<Meta.DatabaseProperty,​java.lang.Object> map,
                         java.lang.Class<T> aClass)

Returns a value of this property, using the default value if the map does not contain an explicit value.

#### fromProto

    public static Meta.DatabaseProperty fromProto​(Common.DatabaseProperty proto)

#### toProto

    public Common.DatabaseProperty toProto()